#include <stdio.h>
#include <stdlib.h>
#include "dictre.h"

static int given = 0;
static int sysallocated = 0;
static void *base = 0;

enum {
    STEP = 5*1024*1024
};

void * fastmalloc(int newsize)
{
    void *outptr;

    outptr = base + given;

    given += newsize;

    if (given > sysallocated)
    {
        if (STEP > newsize)
        {
            base = realloc(base, STEP);
            sysallocated += STEP;
        }
        else
        {
            base = realloc(base, newsize);
            sysallocated += newsize;
        }
    }

    return outptr;
}
