struct Words
{
    struct Word *first;
    int length;
};

struct Word
{
    char *w;
    int def;
};

struct Def
{
    char *d;
    int offset;
    int length;
};

/* write.c */
void write_dictionary(const char *name);

/* dict.c */
char * get_word(FILE *index);
int get_int(FILE *index);
char * get_def(FILE *fdefs, int offset, int length);

/* filter.c */
void filter_all(const char *filter_par);

/* sort.c */
int sort_words();

/* load.c */
void load_init();
void load_dictionary(FILE *index, FILE *fdefs);
void print_words();

/* fastmalloc */
void * fastmalloc(int newsize);
