#include <stdio.h>
#include <stdlib.h>
#include "dictre.h"

extern struct Word words[];
extern int nwords;

static int cmp_words(const void *v1, const void *v2)
{
    struct Word *w1 = (struct Word *) v1;
    struct Word *w2 = (struct Word *) v2;

    return strcmp(w1->w, w2->w);
}

int sort_words()
{
    qsort(words, nwords, sizeof(words[0]), cmp_words);
}
